import { CategoricalStats } from '../../statistics.types';

const updateCategoricalStats = (stats: CategoricalStats, value: string | boolean) => {
  if (!stats.values) stats.values = [];
  stats.values.push(value.toString());

  stats.uniqueItems = new Set(stats.values).size;

  const frequencyMap: { [key: string]: number } = {};
  stats.values.forEach((val) => {
    frequencyMap[val] = (frequencyMap[val] || 0) + 1;
  });
  stats.mode = Object.keys(frequencyMap).reduce((a, b) => (frequencyMap[a] > frequencyMap[b] ? a : b));
};

export { updateCategoricalStats };
